c odtwarzanie struktury pelnoatomowej z reprezentacji gruboziarnistej NARES-2P
c
c co trzeba zrobic?
c
c 1. wczytanie geometrii gruboziarnistej z pdb
c
c 2. przygotowanie zmiennych do trzymania geometrii pelnoatomowej
c
c 3. wstawienie odpowiednio obroconych nukleozydow
c
c    a. subrutyna do obracania
c
c    b. obracanie calej grupy atomow
c
c    c. wczytywanie danych kanonicznej geometrii nukleozydow
c
c    d. jaka os i kat obrotu sa potrzebne
c
c 4. optymalizacja chi i delta przez MC z oddzialywan dipol-dipol i wiezow na centroidy
c
c 5. jw. + odpychanie
c 
c 6. sprawdzenie i naprawienie clashow
c
c 7. rekonstrukcja lancucha cukrowofosforanowego przy zamrozonych zasadach
c
c 8. sprawdzenie i naprawienie clashow
c 
c 9. refinement
c
c 10. sprawdzenie i naprawienie clashow
c
c 11. wypisanie geometrii pelnoatomowej do pdb















!-----------------------------------------------------------------------------
! readpdb.F
!-----------------------------------------------------------------------------
      subroutine readpdb
! Read the PDB file and convert the peptide geometry into virtual-chain 
! geometry.
      use geometry_data
      use energy_data, only: itype,istype
      use control_data
      use compare_data
      use MPI_data
      use control, only: rescode,sugarcode
      integer :: i,j,ibeg,ishift1,ires,iii,ires_old,ishift,k
      logical :: lprn=.true.,fail
      real(kind=8),dimension(3) :: e1,e2,e3
      real(kind=8) :: dcj,efree_temp
      character(len=3) :: seq,res
      character(len=5) :: atom
      character(len=80) :: card
      real(kind=8),dimension(3,20) :: sccor
      integer :: kkk,lll,icha,kupa,molecule,counter,seqalingbegin
      integer :: isugar,molecprev,firstion
      character*1 :: sugar
      real(kind=8) :: cou
      real(kind=8),dimension(3) :: ccc
      integer,dimension(2,maxres/3) :: hfrag_alloc
      integer,dimension(4,maxres/3) :: bfrag_alloc
      real(kind=8),dimension(3,maxres2+2,maxperm) :: cref_alloc
      real(kind=8),dimension(:,:), allocatable  :: c_temporary
      integer,dimension(:,:) , allocatable  :: itype_temporary
      integer,dimension(:),allocatable :: istype_temp
      efree_temp=0.0d0
      ibeg=1
      ishift1=0
      ishift=0
      molecule=1
      counter=0
      ires=0
      ires_old=0
#ifdef WHAM_RUN
      do i=1,nres
         do j=1,5
            itype(i,j)=0
         enddo
      enddo
#endif
      nres=0
      iii=0
      lsecondary=.false.
      nhfrag=0
      nbfrag=0
      do j=1,5
         nres_molec(j)=0
      enddo
      
       
!-----------------------------
      allocate(hfrag(2,maxres/3))
      allocate(bfrag(4,maxres/3))
      if(.not. allocated(istype)) allocate(istype(maxres))
      do i=1,100000
         read (ipdbin,'(a80)',end=10) card
         if (card(:5).eq.'HELIX') then
            nhfrag=nhfrag+1
            lsecondary=.true.
            read(card(22:25),*) hfrag(1,nhfrag)
            read(card(34:37),*) hfrag(2,nhfrag)
         endif
         if (card(:5).eq.'SHEET') then
            nbfrag=nbfrag+1
            lsecondary=.true.
            read(card(24:26),*) bfrag(1,nbfrag)
            read(card(35:37),*) bfrag(2,nbfrag)
!rc----------------------------------------
!rc  to be corrected !!!
            bfrag(3,nbfrag)=bfrag(1,nbfrag)
            bfrag(4,nbfrag)=bfrag(2,nbfrag)
!rc----------------------------------------
         endif
         if (card(:3).eq.'END') then
            goto 10
         else if (card(:3).eq.'TER') then
! End current chain
            ires_old=ires+2
            ishift=ishift+1
            ishift1=ishift1+1
            itype(ires_old,molecule)=ntyp1_molec(molecule)
            itype(ires_old-1,molecule)=ntyp1_molec(molecule)
            nres_molec(molecule)=nres_molec(molecule)+2
            ibeg=2
            if (unres_pdb) then
               do j=1,3
                  dc(j,ires)=sccor(j,iii)
               enddo
            else
               call sccenter(ires,iii,sccor)
            endif
            iii=0
         endif
! Read free energy
         if (index(card,"FREE ENERGY").gt.0) read(card(35:),*) efree_temp
! Fish out the ATOM cards.
         if (index(card(1:4),'ATOM').gt.0) then  
            read (card(12:16),*) atom
            read (card(23:26),*) ires
            read (card(18:20),'(a3)') res
            if (ires-ishift+ishift1.ne.ires_old) then
               if (ibeg.eq.0) then
                  if (unres_pdb) then
                     do j=1,3
                        dc(j,ires+ishift1-ishift-1)=sccor(j,iii)
                     enddo
                  else
                     call sccenter(ires_old,iii,sccor)
                  endif
                  iii=0
               endif
! Start new residue.
               if (res.eq.'Cl-' .or. res.eq.'Na+') then
                  ires=ires_old
                  cycle
               else if (ibeg.eq.1) then
                  write (iout,*) "BEG ires",ires
                  ishift=ires-1
                  if (res.ne.'GLY' .and. res.ne. 'ACE') then
                     ishift=ishift-1
                     itype(1,1)=ntyp1
                     nres_molec(molecule)=nres_molec(molecule)+1
                  endif
                  ires=ires-ishift+ishift1
                  ires_old=ires
                  ibeg=0 
               else if (ibeg.eq.2) then
! Start a new chain
                  ishift=-ires_old+ires-1 !!!!!
                  ishift1=ishift1-1    !!!!!
                  ires=ires-ishift+ishift1
                  ires_old=ires
                  ibeg=0
               else
                  ishift=ishift-(ires-ishift+ishift1-ires_old-1)
                  ires=ires-ishift+ishift1
                  ires_old=ires
               endif 
               if (res.eq.'ACE' .or. res.eq.'NHE') then
                  itype(ires,1)=10
               else
                  if (atom.eq.'CA  '.or.atom.eq.'N   ') then
                     molecule=1
                     itype(ires,molecule)=rescode(ires,res,0,molecule)
                     firstion=0
                  else
                     molecule=2
                     itype(ires,molecule)=rescode(ires,res(2:3),0,molecule)
                     read (card(19:19),'(a1)') sugar
                     isugar=sugarcode(sugar,ires)
                     istype(ires)=isugar

                  endif
               endif
            else
               ires=ires-ishift+ishift1
            endif
!            if (card(27:27).eq."A" .or. card(27:27).eq."B") then
!            endif
            if (atom.eq.'CA'.or. atom.eq.'CH3'.or. &
          res.eq.'NHE'.and.atom(:2).eq.'HN') then
               read(card(31:54),'(3f8.3)') (c(j,ires),j=1,3)
#ifdef DEBUG
               write (iout,'(2i3,2x,a,3f8.3)') &
          ires,itype(ires,1),res,(c(j,ires),j=1,3)
#endif
               iii=iii+1
               nres_molec(molecule)=nres_molec(molecule)+1
               do j=1,3
                  sccor(j,iii)=c(j,ires)
               enddo
            else if (.not.unres_pdb.and.(atom.eq."C1'".or.atom.eq."C2'".or.atom.eq."C3'".or.atom.eq."C4'".or.atom.eq."O4'")) then
               read(card(31:54),'(3f8.3)') (ccc(j),j=1,3)
               counter=counter+1
               do j=1,3
                  c(j,ires)=c(j,ires)+ccc(j)/5.0
               enddo
               print *,counter,molecule
               if (counter.eq.5) then
                  nres_molec(molecule)=nres_molec(molecule)+1
                  firstion=0
                  counter=0
               endif
            else if (atom.eq."C5'") then
               read (card(19:19),'(a1)') sugar
               isugar=sugarcode(sugar,ires)
               if (ibeg.eq.1) then
                  istype(1)=isugar
               else
                  istype(ires)=isugar
               endif
               if (unres_pdb) then
                  molecule=2
                  read(card(31:54),'(3f8.3)') (c(j,ires),j=1,3)
                  nres_molec(molecule)=nres_molec(molecule)+1
                  print *,"nres_molec(molecule)",nres_molec(molecule),ires
               else
                  iii=iii+1
                  read(card(31:54),'(3f8.3)') (sccor(j,iii),j=1,3)
               endif
            else if ((atom.eq."C1'").and.unres_pdb) then
               iii=iii+1
               read(card(31:54),'(3f8.3)') (sccor(j,iii),j=1,3)
            else if (atom.ne.'O'.and.atom(1:1).ne.'H'.and.atom.ne.'N' &
      .and.atom.ne.'C'.and.atom(:2).ne.'1H'.and.atom(:2).ne.'2H'.and. &
      atom.ne.'OXT'.and.atom(:2).ne.'3H'.and.atom.ne.'P  '.and.atom(1:1) &
      .ne.'H'.and.atom.ne.'OP1'.and. atom.ne.'OP2 '.and.atom.ne.'OP3') then
               if ((molecule.ne.2).or.(atom(3:3).ne."'")) then
                  iii=iii+1
                  read(card(31:54),'(3f8.3)') (sccor(j,iii),j=1,3)
               endif
            endif
         else if ((ions).and.(card(1:6).eq.'HETATM')) then
            if (firstion.eq.0) then 
               firstion=1
               if (unres_pdb) then
                  do j=1,3
                     dc(j,ires)=sccor(j,iii)
                  enddo
               else
                  call sccenter(ires,iii,sccor)
               endif
            endif
            read (card(12:16),*) atom
            print *,"HETATOM", atom
            read (card(18:20),'(a3)') res
            if ((atom(1:2).eq.'NA').or.(atom(1:2).eq.'CL').or. &
      (atom(1:2).eq.'CA').or.(atom(1:2).eq.'MG').or.(atom(1:2).eq.'K ')) then
            ires=ires+1
            if (molecule.ne.5) molecprev=molecule
               molecule=5
               nres_molec(molecule)=nres_molec(molecule)+1
               print *,"HERE",nres_molec(molecule)
               res=res(2:3)//' '
               itype(ires,molecule)=rescode(ires,res,0,molecule)
               read(card(31:54),'(3f8.3)') (c(j,ires),j=1,3)
            endif
         endif !atom
      enddo
   10 write (iout,'(a,i5)') ' Number of residues found: ',ires
      if (ires.eq.0) return
! Calculate dummy residue coordinates inside the "chain" of a multichain
! system
      nres=ires
      if ((ires_old.ne.ires).and.(molecule.ne.5)) &
       nres_molec(molecule)=nres_molec(molecule)-2
      print *,'I have',nres, nres_molec(:)
      do k=1,4 ! ions are without dummy 
         if (nres_molec(k).eq.0) cycle
         do i=2,nres-1
            if (itype(i,k).eq.ntyp1_molec(k)) then
               if (itype(i+1,k).eq.ntyp1_molec(k)) then
                  if (itype(i+2,k).eq.0) then 
                     do j=1,5
                        if (itype(i+2,j).ne.0) then
                           itype(i+1,k)=0
                           itype(i+1,j)=ntyp1_molec(j)
                           nres_molec(k)=nres_molec(k)-1
                           nres_molec(j)=nres_molec(j)+1
                           go to 3331
                        endif
                     enddo
 3331                continue
                  endif
! 16/01/2014 by Adasko: Adding to dummy atoms in the chain
! first is connected prevous chain (itype(i+1,1).eq.ntyp1)=true
! second dummy atom is conected to next chain itype(i+1,1).eq.ntyp1=false
!           if (unres_pdb) then
! 2/15/2013 by Adam: corrected insertion of the last dummy residue
                  do j=1,3
                     dcj=(c(j,i-2)-c(j,i-3))/2.0
                     if (dcj.eq.0) dcj=1.23591524223
                     c(j,i)=c(j,i-1)+dcj
                     c(j,nres+i)=c(j,i)
                  enddo
               else
! 2/15/2013 by Adam: corrected insertion of the first dummy residue
                  do j=1,3
                     c(j,i)=c(j,i+1)-1.9d0*e2(j)
                  enddo
                  do j=1,3
                     dcj=(c(j,i+3)-c(j,i+2))/2.0
                     if (dcj.eq.0) dcj=1.23591524223
                     c(j,i)=c(j,i+1)-dcj
                     c(j,nres+i)=c(j,i)
                  enddo
               endif !itype(i+1,1).eq.ntyp1
            endif  !itype.eq.ntyp1
         enddo
      enddo
! Calculate the CM of the last side chain.
      if (iii.gt.0)  then
         if (unres_pdb) then
            do j=1,3
               dc(j,ires)=sccor(j,iii)
            enddo
         else
            call sccenter(ires,iii,sccor)
         endif
      endif
      nsup=nres
      nstart_sup=1
      if ((itype(nres,1).ne.10)) then
         nres=nres+1
         if (molecule.eq.5) molecule=molecprev
         itype(nres,molecule)=ntyp1_molec(molecule)
         nres_molec(molecule)=nres_molec(molecule)+1
! 2/15/2013 by Adam: corrected insertion of the last dummy residue
         do j=1,3
            dcj=(c(j,nres-2)-c(j,nres-3))/2.0
            c(j,nres)=c(j,nres-1)+dcj
            c(j,2*nres)=c(j,nres)
         enddo
      endif

!el kontrola nres w pliku inputowym WHAM-a w porownaniu z wartoscia wczytana z pliku pdb
#ifdef WHAM_RUN
      if (nres.ne.nres0) then
         write (iout,*) "Error: wrong parameter value: NRES=",nres, &
                        " NRES0=",nres0
         stop "Error nres value in WHAM input"
      endif
#endif
      do i=2,nres-1
         do j=1,3
            c(j,i+nres)=dc(j,i)
         enddo
      enddo
      do j=1,3
         c(j,nres+1)=c(j,1)
         c(j,2*nres)=c(j,nres)
      enddo
      if (itype(1,1).eq.ntyp1) then
         nsup=nsup-1
         nstart_sup=2
         if (unres_pdb) then
! 2/15/2013 by Adam: corrected insertion of the first dummy residue
            call refsys(2,3,4,e1,e2,e3,fail)
            if (fail) then
               e2(1)=0.0d0
               e2(2)=1.0d0
               e2(3)=0.0d0
            endif
            do j=1,3
               c(j,1)=c(j,2)-1.9d0*e2(j)
            enddo
         else
            do j=1,3
               dcj=(c(j,4)-c(j,3))/2.0
               c(j,1)=c(j,2)-dcj
               c(j,nres+1)=c(j,1)
            enddo
         endif
      endif
! First lets assign correct dummy to correct type of chain
! 1) First residue
      if (itype(1,1).eq.ntyp1) then
         if (itype(2,1).eq.0) then
            do j=2,5
               if (itype(2,j).ne.0) then
                  itype(1,1)=0
                  itype(1,j)=ntyp1_molec(j)
                  nres_molec(1)=nres_molec(1)-1
                  nres_molec(j)=nres_molec(j)+1
                  go to 3231
               endif
            enddo
3231        continue
         endif
      endif
      print *,'I have',nres, nres_molec(:)

! Copy the coordinates to reference coordinates
! Calculate internal coordinates.
      if (lprn) then
         write (iout,'(/a)') "Cartesian coordinates of the reference structure"
         write (iout,'(a,3(3x,a5),5x,3(3x,a5))') "Residue","X(CA)","Y(CA)", &
                "Z(CA)","X(SC)","Y(SC)","Z(SC)"
         do ires=1,nres
            write (iout,'(5(a3,1x),i3,3f8.3,5x,3f8.3)') &
      (restyp(itype(ires,j),j),j=1,5),ires,(c(j,ires),j=1,3),(c(j,ires+nres),j=1,3)
         enddo
      endif
! znamy już nres wiec mozna alokowac tablice
! Calculate internal coordinates.
      if(me.eq.king.or..not.out1file)then
         write (iout,'(a)')  &
      "Backbone and SC coordinates as read from the PDB"
         do ires=1,nres
            write (iout,'(2i3,2x,a,3f8.3,5x,3f8.3)') ires,itype(ires,1), &
        restyp(itype(ires,1),1),(c(j,ires),j=1,3),(c(j,nres+ires),j=1,3)
         enddo
      endif
! NOW LETS ROCK! SORTING
      allocate(c_temporary(3,2*nres))
      allocate(itype_temporary(nres,5))
      if (.not.allocated(molnum)) allocate(molnum(nres+1))
      if (.not.allocated(istype)) write(iout,*) &
                   "SOMETHING WRONG WITH ISTYTPE"
      allocate(istype_temp(nres))
      itype_temporary(:,:)=0
      seqalingbegin=1
      do k=1,5
         do i=1,nres
            if (itype(i,k).ne.0) then
               do j=1,3
                  c_temporary(j,seqalingbegin)=c(j,i)
                  c_temporary(j,seqalingbegin+nres)=c(j,i+nres)
               enddo
               itype_temporary(seqalingbegin,k)=itype(i,k)
               print *,i,k,itype(i,k),itype_temporary(seqalingbegin,k),seqalingbegin
               istype_temp(seqalingbegin)=istype(i)
               molnum(seqalingbegin)=k
               seqalingbegin=seqalingbegin+1
            endif
         enddo
      enddo
      do i=1,2*nres
         do j=1,3
            c(j,i)=c_temporary(j,i)
         enddo
      enddo
      do k=1,5
         do i=1,nres
            itype(i,k)=itype_temporary(i,k)
            istype(i)=istype_temp(i)
         enddo
      enddo
! 2/15/2013 by Adam: corrected insertion of the first dummy residue
      if (lprn) then
         write (iout,'(/a)') &
      "Cartesian coordinates of the reference structure after sorting"
         write (iout,'(a,3(3x,a5),5x,3(3x,a5))') "Residue","X(CA)", &
                           "Y(CA)","Z(CA)","X(SC)","Y(SC)","Z(SC)"
         do ires=1,nres
            write (iout,'(5(a3,1x),i3,3f8.3,5x,3f8.3)') &
      (restyp(itype(ires,j),j),j=1,5),ires,(c(j,ires),j=1,3),(c(j,ires+nres),j=1,3)
         enddo
      endif
      if(.not.allocated(vbld)) then
         allocate(vbld(2*nres))
         do i=1,2*nres
            vbld(i)=0.d0
         enddo
      endif
      if(.not.allocated(vbld_inv)) then
         allocate(vbld_inv(2*nres))
         do i=1,2*nres
            vbld_inv(i)=0.d0
         enddo
      endif
      if(.not.allocated(theta)) then
         allocate(theta(nres+2))
         theta(:)=0.0d0
      endif
      if(.not.allocated(phi)) allocate(phi(nres+2))
      if(.not.allocated(alph)) allocate(alph(nres+2))
      if(.not.allocated(omeg)) allocate(omeg(nres+2))
      if(.not.allocated(thetaref)) allocate(thetaref(nres+2))
      if(.not.allocated(phiref)) allocate(phiref(nres+2))
      if(.not.allocated(costtab)) allocate(costtab(nres))
      if(.not.allocated(sinttab)) allocate(sinttab(nres))
      if(.not.allocated(cost2tab)) allocate(cost2tab(nres))
      if(.not.allocated(sint2tab)) allocate(sint2tab(nres))
      if(.not.allocated(xxref)) allocate(xxref(nres))
      if(.not.allocated(yyref)) allocate(yyref(nres))
      if(.not.allocated(zzref)) allocate(zzref(nres))
      if(.not.allocated(dc_norm)) then
         allocate(dc_norm(3,0:2*nres+2))
         dc_norm(:,:)=0.d0
      endif
      call int_from_cart(.true.,.false.)
      call sc_loc_geom(.false.)
      do i=1,nres
         thetaref(i)=theta(i)
         phiref(i)=phi(i)
      enddo
      do i=1,nres-1
         do j=1,3
            dc(j,i)=c(j,i+1)-c(j,i)
            dc_norm(j,i)=dc(j,i)*vbld_inv(i+1)
         enddo
      enddo
      do i=2,nres-1
         do j=1,3
            dc(j,i+nres)=c(j,i+nres)-c(j,i)
            dc_norm(j,i+nres)=dc(j,i+nres)*vbld_inv(i+nres)
         enddo
      enddo
      if(.not.allocated(cref)) allocate(cref(3,2*nres+2,maxperm))
      if(.not.allocated(chain_rep)) allocate(chain_rep(3,2*nres+2,maxsym))
      if(.not.allocated(tabperm)) allocate(tabperm(maxperm,maxsym))
!-----------------------------
      kkk=1
      lll=0
      cou=1
      write (iout,*) "symetr", symetr
      do i=1,nres
         lll=lll+1
         if (i.gt.1) then
            if ((itype(i-1,1).eq.ntyp1).and.(i.gt.2)) then
               chain_length=lll-1
               kkk=kkk+1
               lll=1
            endif
         endif
         do j=1,3
            cref(j,i,cou)=c(j,i)
            cref(j,i+nres,cou)=c(j,i+nres)
            if (i.le.nres) then
               chain_rep(j,lll,kkk)=c(j,i)
               chain_rep(j,lll+nres,kkk)=c(j,i+nres)
            endif
         enddo
      enddo
      write (iout,*) chain_length
      if (chain_length.eq.0) chain_length=nres
      do j=1,3
         chain_rep(j,chain_length,symetr)=chain_rep(j,chain_length,1)
         chain_rep(j,chain_length+nres,symetr)=chain_rep(j,chain_length+nres,1)
      enddo
! makes copy of chains
      write (iout,*) "symetr", symetr
      do j=1,3
         dc(j,0)=c(j,1)
      enddo
      if (symetr.gt.1) then
         call permut(symetr)
         nperm=1
         do i=1,symetr
            nperm=nperm*i
         enddo
         do i=1,nperm
            write(iout,*) (tabperm(i,kkk),kkk=1,4)
         enddo
         do i=1,nperm
            cou=0
            do kkk=1,symetr
               icha=tabperm(i,kkk)
               do lll=1,chain_length
                  cou=cou+1
                  if (cou.le.nres) then
                     do j=1,3
                        kupa=mod(lll,chain_length)
                        iprzes=(kkk-1)*chain_length+lll
                        if (kupa.eq.0) kupa=chain_length
                           cref(j,iprzes,i)=chain_rep(j,kupa,icha)
                           cref(j,iprzes+nres,i)=chain_rep(j,kupa+nres,icha)
                     enddo
                  endif
               enddo
            enddo
         enddo
      endif
!-koniec robienia kopii
! diag
      do kkk=1,nperm
         write (iout,*) "nowa struktura", nperm
         do i=1,nres
            write (iout,110) restyp(itype(i,1),1),i,cref(1,i,kkk),cref(2,i,kkk), &
      cref(3,i,kkk),cref(1,nres+i,kkk),cref(2,nres+i,kkk),cref(3,nres+i,kkk)
         enddo
  100 format (//'              alpha-carbon coordinates       ',&
                '     centroid coordinates'/ &
                '       ', 6X,'X',11X,'Y',11X,'Z', &
                                10X,'X',11X,'Y',11X,'Z')
  110 format (a,'(',i3,')',6f12.5)
      enddo
!c enddiag
      do j=1,nbfrag     
         do i=1,4                                                       
            bfrag(i,j)=bfrag(i,j)-ishift
         enddo
      enddo
      do j=1,nhfrag
         do i=1,2
            hfrag(i,j)=hfrag(i,j)-ishift
         enddo
      enddo
      ishift_pdb=ishift
      return
      end subroutine readpdb
!-----------------------------------------------------------------------------
      subroutine makeallatom
      use geometry_data
      use energy_data, only: itype,istype
      use control_data
      use compare_data
      use MPI_data
      use rotation
      real(kind=8),dimension(3) x,y,center,zero
      real(kind=8),dimension(4) rotq
      real(kind=8),dimension(3,34) incoord,outcoord
      data zero/0,0,0/
      natom=0
      do i=1,nres
         natom=natom+resnatom(sug,bas)    
      enddo
      allocate coordat(3,natom),atname(natom)
      iatom=0
      do i=2,nres-1
         sug=istype(i)
         bas=itype(i,2)
         do j=1,3
            center(j)=c(j,i)+0.5*dc(j,i+nres)
            x(j)=dc(j,i+nres)
            y(j)=c(j,i+1)-c(j,i-1)
         enddo
         call findrot(x,y,rotq)
         n=resnatom(sug,bas)
         do j=1,3 
            do k=1,n
               incoord(j,k)=rescoord(sug,bas,j,k)
            enddo
         enddo
         call grouprot(zero,rotq,incoord,outcoord,n)
         do j=1,n
            iatom=iatom+1
            atname(iatom)=resat(sug,bas,n)
            do k=1,3
               coordat(k,iatom)=outcoord(k,j)+center(k)
            enddo
         enddo   
      enddo
      end subroutine makeallatom
!-----------------------------------------------------------------------------
      subroutine readres
      use geometry_data
      use energy_data, only: itype,istype
      use control_data
      use compare_data
      use MPI_data
      character(len=30) :: path,fullname
      logical :: filex
      allocate resnatom(2,5),resat(2,5,34),rescoord(2,5,3,34)
      path="../source/data/geom/"
      do i=1,5
         fullname=path//"D"//resname(2,i)//".pdb"
         inquire(file=fullname,exist=filex)
         if filex then
            open(666,file=fullname)
            j=0
            do
               read(666,'(12x,a5,13x,3f8.3)',end=1337) resat(1,i,j+1),(res(1,i,k,j+1),k=1,3)
               j=j+1
               cycle
1337           exit
            enddo
            resnatom(1,i)=j
            close(666)
         else
            resnatom(1,i)=0
         endif
         fullname=path//resname(2,i)//".pdb"
         inquire(file=fullname,exist=filex)
         if filex then
            open(666,file=fullname)
            j=0
            do
               read(666,'(12x,a5,13x,3f8.3)',end=1338) resat(2,i,j+1),(res(2,i,k,j+1),k=1,3)
               j=j+1
               cycle
1338           exit
            enddo
            resnatom(2,i)=j
            close(666)
         else
            resnatom(2,i)=0
         endif
      enddo         
      end subroutine readres
