!c odtwarzanie struktury pelnoatomowej z reprezentacji gruboziarnistej NARES-2P
!c
!c co trzeba zrobic?
!c
!c 1. wczytanie geometrii gruboziarnistej z pdb v
!
!     a. wspolrzedne nukleozydow jako bryly sztywnej - pozycja + kwaternion obrotu v
!
!     b. wspolrzedne wewnetrzne nukleozydow
!c
!c 2. przygotowanie zmiennych do trzymania geometrii pelnoatomowej v
!c
!c 3. wstawienie odpowiednio obroconych nukleozydow v
!c
!c    a. subrutyna do obracania v
!c
!c    b. obracanie calej grupy atomow v
!c
!c    c. wczytywanie danych kanonicznej geometrii nukleozydow v
!
!        1. wczytywanie roznych konformerow
!c
!c    d. jaka os i kat obrotu sa potrzebne v
!c
!c 4. optymalizacja chi i delta przez MC z oddzialywan dipol-dipol i wiezow na centroidy
!c
!     a. monte carlo
!
!        1. obrot wokol osi cukier-zasada
!
!        2. obrot osi cukier-zasada
!
!        3. translacja
!
!        4. zmiana konformacji
!
!     b. skladniki energii
!
!        1. wiezy na O3' i C5'
!
!        2. dipol-dipol
!
!        3. wiezy na cukier i zasade
!
!c 5. jw. + odpychanie
!c 
!c 6. sprawdzenie i naprawienie clashow
!c
!c 7. rekonstrukcja lancucha cukrowofosforanowego przy zamrozonych zasadach
!c
!c 8. sprawdzenie i naprawienie clashow
!c 
!c 9. refinement
!c
!c 10. sprawdzenie i naprawienie clashow
!c
!c 11. wypisanie geometrii pelnoatomowej do pdb v

      program lupa
      use io_base
      use io_units
      use geometry
      use energy
      use energy_data
      use geometry_data
      character(len=80) :: inpdbname,outpdbname,title,exec,exepath
      real(kind=8) :: e
      call getarg(1,inpdbname)
      call getarg(2,outpdbname)
      call getarg(0,exec)
      call getpath(exec,exepath)
      k0=100
      md=2.9
      call readres(exepath)
      ipdbin=2
      open (ipdbin,file=inpdbname,status='old',action='read')
      iout=3
      open(iout,file="lupa.log",status='unknown')
      unres_pdb=.TRUE.
      allocate(itype(maxres,5))
      allocate(c(3,2*maxres+2))
      allocate(dc(3,0:2*maxres))
      call readpdb
      close(ipdbin)
      call initgeom
      do i=1,nres
         if (itype(i,2).ne.ntyp1_molec(2)) then
            call update(i)
         endif
      enddo
      call etotal(e)
      print *, "total energy = ",e,"kcal/mol"
      call makeallatom
      ipdbout=4
      open(ipdbout,file=outpdbname,status='unknown')
      title="lupa "//inpdbname//" output"
      call pdbout(title,ipdbout)
      close(ipdbout)
      close(iout)
      end program
      subroutine getpath(fil,path)
      character(len=26) :: fil, path
      n=index(fil,"lupa.exe")
      path=trim(fil(1:n-1))
      end subroutine 
